//
//  T9-interface
//
//  - 2006. 7. 26. Dong-Chul Kim
//    http://www.opencv.co.kr
//    http://www.t9t9.com
//

#include <cv.h>
#include <highgui.h>

#define	WIN_NAME1	"T9-screen"

// ȭ ũ
int VIEW_WIDTH	= 640;
int VIEW_HEIGHT	= 480;

#define VIEW_1_W	160
#define VIEW_1_H	120

#define VIEW_2_W	320
#define VIEW_2_H	240

#define VIEW_3_W	640
#define VIEW_3_H	480

#define VIEW_4_W	800
#define VIEW_4_H	600

#define VIEW_5_W	1024
#define VIEW_5_H	768

bool bChangedView = 0;

//  
#define LINE_HEIGHT		12

// 
#define MARGIN_LEFT		10
#define MARGIN_BOTTOM	10

// Ʈ ũ
const float font_size = 0.7f;

const int width = 640,
			height = 480;

bool bVisibleMenu = 1;
bool bTracking = 0;

CvFont* font = new CvFont;

struct stPoint{
	int x;
	int y;
};

struct stObject{
	int ID;
	int Time;
	int Speed;
	stPoint Pos;
	stPoint Size;
	bool bVisible;
} Object[100];

int Tot_Obj;
int Visible_Obj;

int Map[height][width]={0};

void ShowMenu(IplImage* img)
{
	int MENU_HEIGHT = MARGIN_BOTTOM;

	cvPutText(img, "OpenCV.co.kr", cvPoint(VIEW_WIDTH - 88, VIEW_HEIGHT - 23), font, CV_RGB(255,0,0));

	if(bVisibleMenu){
		cvPutText(img, "5: 1024 x 768 pixels", cvPoint(MARGIN_LEFT, MENU_HEIGHT), font, CV_RGB(255,0,0));
		MENU_HEIGHT += LINE_HEIGHT;

		cvPutText(img, "4: 800 x 600 pixels", cvPoint(MARGIN_LEFT, MENU_HEIGHT), font, CV_RGB(255,0,0));
		MENU_HEIGHT += LINE_HEIGHT;

		cvPutText(img, "3: 640 x 480 pixels", cvPoint(MARGIN_LEFT, MENU_HEIGHT), font, CV_RGB(255,0,0));
		MENU_HEIGHT += LINE_HEIGHT;

		cvPutText(img, "2: 320 x 240 pixels", cvPoint(MARGIN_LEFT, MENU_HEIGHT), font, CV_RGB(255,0,0));
		MENU_HEIGHT += LINE_HEIGHT;
		
		cvPutText(img, "1: 160 x 120 pixels", cvPoint(MARGIN_LEFT, MENU_HEIGHT), font, CV_RGB(255,0,0));
		MENU_HEIGHT += LINE_HEIGHT;

		cvPutText(img, "-: Decrease size", cvPoint(MARGIN_LEFT, MENU_HEIGHT), font, CV_RGB(255,0,0));
		MENU_HEIGHT += LINE_HEIGHT;

		cvPutText(img, "+: Increase size", cvPoint(MARGIN_LEFT, MENU_HEIGHT), font, CV_RGB(255,0,0));
		MENU_HEIGHT += LINE_HEIGHT;
	}
}

IplImage* Tracking(IplImage* bg_img, IplImage* img)
{
	IplImage* diff = cvCloneImage(img);

	memset(Map, 0, sizeof(Map));

	cvAbsDiff(bg_img, img, diff);
	
	// get pick area
	int i, j;
	unsigned char r, g, b;


	for(i=0; i<diff->height; i+=2){
		for(j=0; j<diff->width; j+=2){
			if(Map[i][j] == 0){
				b = diff->imageData[ i * diff->widthStep + j * 3 + 0];
				g = diff->imageData[ i * diff->widthStep + j * 3 + 1];
				r = diff->imageData[ i * diff->widthStep + j * 3 + 2];
				
				if( ( r + g + b ) / 3 > 16 ){
					img->imageData[ i * img->widthStep + j * 3 + 0] = 0;
					img->imageData[ i * img->widthStep + j * 3 + 1] = 255;
					img->imageData[ i * img->widthStep + j * 3 + 2] = 0;
				}
			}
		}
	}

	// register Object
	// labeling
	

	// pos

	// size

	return img;
}

void main()
{
    IplImage* image = 0;
	IplImage* ori_image = 0;
    IplImage* view_image = 0;

    IplImage* bg_image = 0;
	IplImage* diff_image = 0;

	int c;

	cvInitFont(font, CV_FONT_HERSHEY_PLAIN , font_size, 1.0f, 0, 1, CV_AA);

    CvCapture* capture = 0;  
	capture = cvCaptureFromCAM(0);

	// ī޶ Է 
	cvSetCaptureProperty(capture,CV_CAP_PROP_FRAME_WIDTH, width);
	cvSetCaptureProperty(capture,CV_CAP_PROP_FRAME_HEIGHT, height);


    if( capture )
    {
        cvNamedWindow( WIN_NAME1, 0 );
		cvResizeWindow( WIN_NAME1, VIEW_WIDTH, VIEW_HEIGHT );
        
		while(1)
        {
			ori_image = cvQueryFrame( capture );
			image = cvCloneImage(ori_image);
			
			if(bTracking)
				Tracking(bg_image, image);


			// View   ==========
			// View ũ⸸ŭ Ȯ
			if(!view_image)
				view_image = cvCreateImage( cvSize(VIEW_WIDTH, VIEW_HEIGHT), image->depth, image->nChannels );

			if(bChangedView){
				view_image = cvCreateImage( cvSize(VIEW_WIDTH, VIEW_HEIGHT), image->depth, image->nChannels );
				bChangedView = 0;
			}

			cvResize( image, view_image, CV_INTER_LINEAR );
			
			ShowMenu(view_image);

	        c = cvWaitKey(10);

			if( c == 27 || c == 'q') // ESC
				break;

			switch( c )
			{
			case '1':
				cvResizeWindow( WIN_NAME1, VIEW_1_W, VIEW_1_H);
				VIEW_WIDTH = VIEW_1_W;
				VIEW_HEIGHT = VIEW_1_H;
				bChangedView = 1;
				break;
			case '2':
				cvResizeWindow( WIN_NAME1, VIEW_2_W, VIEW_2_H);
				VIEW_WIDTH = VIEW_2_W;
				VIEW_HEIGHT = VIEW_2_H;
				bChangedView = 1;
				break;
			case '3':
				cvResizeWindow( WIN_NAME1, VIEW_3_W, VIEW_3_H);
				VIEW_WIDTH = VIEW_3_W;
				VIEW_HEIGHT = VIEW_3_H;
				bChangedView = 1;
				break;
			case '4':
				cvResizeWindow( WIN_NAME1, VIEW_4_W, VIEW_4_H);
				VIEW_WIDTH = VIEW_4_W;
				VIEW_HEIGHT = VIEW_4_H;
				bChangedView = 1;
				break;
			case '5':
				cvResizeWindow( WIN_NAME1, VIEW_5_W, VIEW_5_H);
				VIEW_WIDTH = VIEW_5_W;
				VIEW_HEIGHT = VIEW_5_H;
				bChangedView = 1;
				break;
			case '-':
				VIEW_WIDTH -= 10;
				VIEW_HEIGHT -= 10;
				cvResizeWindow( WIN_NAME1, VIEW_WIDTH, VIEW_HEIGHT);
				bChangedView = 1;
				break;
			case '+':
				VIEW_WIDTH += 10;
				VIEW_HEIGHT += 10;
				cvResizeWindow( WIN_NAME1, VIEW_WIDTH, VIEW_HEIGHT);
				bChangedView = 1;
				break;

			default:
				;
			}
			
			view_image->origin = image->origin;

			cvShowImage( WIN_NAME1, view_image );

		}
        cvReleaseCapture( &capture );
        cvDestroyWindow( WIN_NAME1 );
    }
	delete font;
}